<html>
<head>
<title>OGRE: Ogre::HardwareOcclusionQuery Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li class="current"><a href="classes.html"><span>Classes</span></a></li>
    <li><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="tabs">
  <ul>
    <li><a href="classes.html"><span>Alphabetical&nbsp;List</span></a></li>
    <li><a href="annotated.html"><span>Class&nbsp;List</span></a></li>
    <li><a href="hierarchy.html"><span>Class&nbsp;Hierarchy</span></a></li>
    <li><a href="functions.html"><span>Class&nbsp;Members</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="namespaceOgre.html">Ogre</a>::<a class="el" href="classOgre_1_1HardwareOcclusionQuery.html">HardwareOcclusionQuery</a></div>
<h1>Ogre::HardwareOcclusionQuery Class Reference</h1><!-- doxytag: class="Ogre::HardwareOcclusionQuery" -->This is a abstract class that that provides the interface for the query class for hardware occlusion.  
<a href="#_details">More...</a>
<p>
<code>#include &lt;<a class="el" href="OgreHardwareOcclusionQuery_8h-source.html">OgreHardwareOcclusionQuery.h</a>&gt;</code>
<p>

<p>
<a href="classOgre_1_1HardwareOcclusionQuery-members.html">List of all members.</a><table border="0" cellpadding="0" cellspacing="0">
<tr><td></td></tr>
<tr><td colspan="2"><br><h2>Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareOcclusionQuery.html#4d2546c8e312ca97b34e9563d2bfb0a3">HardwareOcclusionQuery</a> ()</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Object public member functions.  <a href="#4d2546c8e312ca97b34e9563d2bfb0a3"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareOcclusionQuery.html#713fc5b2a2e0ab14843fc381f8d93f99">~HardwareOcclusionQuery</a> ()</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Object destructor.  <a href="#713fc5b2a2e0ab14843fc381f8d93f99"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareOcclusionQuery.html#40efe70ae4a5877fadd5ef40b2e5fcf3">beginOcclusionQuery</a> ()=0</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Starts the hardware occlusion query  Simple usage: Create one or more OcclusionQuery object one per outstanding query or one per tested object OcclusionQuery* m_pOcclusionQuery; createOcclusionQuery( &amp;m_pOcclusionQuery ); In the rendering loop: Draw all occluders m_pOcclusionQuery-&gt;startOcclusionQuery(); Draw the polygons to be tested m_pOcclusionQuery-&gt;<a class="el" href="classOgre_1_1HardwareOcclusionQuery.html#ae324a11ce1f97199024d1ee38a297c2" title="Ends the hardware occlusion test.">endOcclusionQuery()</a>;.  <a href="#40efe70ae4a5877fadd5ef40b2e5fcf3"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareOcclusionQuery.html#ae324a11ce1f97199024d1ee38a297c2">endOcclusionQuery</a> ()=0</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Ends the hardware occlusion test.  <a href="#ae324a11ce1f97199024d1ee38a297c2"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareOcclusionQuery.html#e30ceda53d771c5db266fdcfd14e6c9c">pullOcclusionQuery</a> (unsigned int *NumOfFragments)=0</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Pulls the hardware occlusion query.  <a href="#e30ceda53d771c5db266fdcfd14e6c9c"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">unsigned int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareOcclusionQuery.html#e90c7bb824d1fdffe1ea35549217a5c7">getLastQuerysPixelcount</a> () const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Let's you get the last pixel count with out doing the hardware occlusion test.  <a href="#e90c7bb824d1fdffe1ea35549217a5c7"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareOcclusionQuery.html#bdc85b8e78de55492c8d2d730150e08d">isStillOutstanding</a> (void)=0</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Lets you know when query is done, or still be processed by the Hardware.  <a href="#bdc85b8e78de55492c8d2d730150e08d"></a><br></td></tr>
<tr><td colspan="2"><br><h2>Protected Attributes</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">unsigned int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareOcclusionQuery.html#d9ae2ba4b9c5f443a8bb423ddeb6121b">mPixelCount</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareOcclusionQuery.html#320c1bab88bacc137b8d939a1785da7b">mIsQueryResultStillOutstanding</a></td></tr>

</table>
<hr><a name="_details"></a><h2>Detailed Description</h2>
This is a abstract class that that provides the interface for the query class for hardware occlusion. 
<p>
<dl class="author" compact><dt><b>Author:</b></dt><dd>Lee Sandberg Updated on 13/8/2005 by Tuan Kuranes email: <a href="mailto:tuan.kuranes@free.fr">tuan.kuranes@free.fr</a> </dd></dl>

<p>Definition at line <a class="el" href="OgreHardwareOcclusionQuery_8h-source.html#l00046">46</a> of file <a class="el" href="OgreHardwareOcclusionQuery_8h-source.html">OgreHardwareOcclusionQuery.h</a>.</p>
<hr><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" name="4d2546c8e312ca97b34e9563d2bfb0a3"></a><!-- doxytag: member="Ogre::HardwareOcclusionQuery::HardwareOcclusionQuery" ref="4d2546c8e312ca97b34e9563d2bfb0a3" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Ogre::HardwareOcclusionQuery::HardwareOcclusionQuery           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Object public member functions. 
<p>
Default object constructor 
</div>
</div><p>
<a class="anchor" name="713fc5b2a2e0ab14843fc381f8d93f99"></a><!-- doxytag: member="Ogre::HardwareOcclusionQuery::~HardwareOcclusionQuery" ref="713fc5b2a2e0ab14843fc381f8d93f99" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual Ogre::HardwareOcclusionQuery::~HardwareOcclusionQuery           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Object destructor. 
<p>

</div>
</div><p>
<hr><h2>Member Function Documentation</h2>
<a class="anchor" name="40efe70ae4a5877fadd5ef40b2e5fcf3"></a><!-- doxytag: member="Ogre::HardwareOcclusionQuery::beginOcclusionQuery" ref="40efe70ae4a5877fadd5ef40b2e5fcf3" args="()=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Ogre::HardwareOcclusionQuery::beginOcclusionQuery           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Starts the hardware occlusion query  Simple usage: Create one or more OcclusionQuery object one per outstanding query or one per tested object OcclusionQuery* m_pOcclusionQuery; createOcclusionQuery( &amp;m_pOcclusionQuery ); In the rendering loop: Draw all occluders m_pOcclusionQuery-&gt;startOcclusionQuery(); Draw the polygons to be tested m_pOcclusionQuery-&gt;<a class="el" href="classOgre_1_1HardwareOcclusionQuery.html#ae324a11ce1f97199024d1ee38a297c2" title="Ends the hardware occlusion test.">endOcclusionQuery()</a>;. 
<p>
Results must be pulled using: UINT m_uintNumberOfPixelsVisable; pullOcclusionQuery( &amp;m_dwNumberOfPixelsVisable ); 
</div>
</div><p>
<a class="anchor" name="ae324a11ce1f97199024d1ee38a297c2"></a><!-- doxytag: member="Ogre::HardwareOcclusionQuery::endOcclusionQuery" ref="ae324a11ce1f97199024d1ee38a297c2" args="()=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Ogre::HardwareOcclusionQuery::endOcclusionQuery           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Ends the hardware occlusion test. 
<p>

</div>
</div><p>
<a class="anchor" name="e30ceda53d771c5db266fdcfd14e6c9c"></a><!-- doxytag: member="Ogre::HardwareOcclusionQuery::pullOcclusionQuery" ref="e30ceda53d771c5db266fdcfd14e6c9c" args="(unsigned int *NumOfFragments)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool Ogre::HardwareOcclusionQuery::pullOcclusionQuery           </td>
          <td>(</td>
          <td class="paramtype">unsigned int *&nbsp;</td>
          <td class="paramname"> <em>NumOfFragments</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Pulls the hardware occlusion query. 
<p>
<dl class="note" compact><dt><b>Note:</b></dt><dd>Waits until the query result is available; use isStillOutstanding if just want to test if the result is available. </dd></dl>
<dl compact><dt><b>Return values:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>NumOfFragments</em>&nbsp;</td><td>will get the resulting number of fragments. </td></tr>
  </table>
</dl>
<dl class="return" compact><dt><b>Returns:</b></dt><dd>True if success or false if not. </dd></dl>

</div>
</div><p>
<a class="anchor" name="e90c7bb824d1fdffe1ea35549217a5c7"></a><!-- doxytag: member="Ogre::HardwareOcclusionQuery::getLastQuerysPixelcount" ref="e90c7bb824d1fdffe1ea35549217a5c7" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">unsigned int Ogre::HardwareOcclusionQuery::getLastQuerysPixelcount           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Let's you get the last pixel count with out doing the hardware occlusion test. 
<p>
<dl class="return" compact><dt><b>Returns:</b></dt><dd>The last fragment count from the last test. Remarks This function won't give you new values, just the old value. </dd></dl>

<p>Definition at line <a class="el" href="OgreHardwareOcclusionQuery_8h-source.html#l00104">104</a> of file <a class="el" href="OgreHardwareOcclusionQuery_8h-source.html">OgreHardwareOcclusionQuery.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="bdc85b8e78de55492c8d2d730150e08d"></a><!-- doxytag: member="Ogre::HardwareOcclusionQuery::isStillOutstanding" ref="bdc85b8e78de55492c8d2d730150e08d" args="(void)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool Ogre::HardwareOcclusionQuery::isStillOutstanding           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Lets you know when query is done, or still be processed by the Hardware. 
<p>
<dl class="return" compact><dt><b>Returns:</b></dt><dd>true if query isn't finished. </dd></dl>

</div>
</div><p>
<hr><h2>Member Data Documentation</h2>
<a class="anchor" name="d9ae2ba4b9c5f443a8bb423ddeb6121b"></a><!-- doxytag: member="Ogre::HardwareOcclusionQuery::mPixelCount" ref="d9ae2ba4b9c5f443a8bb423ddeb6121b" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">unsigned int <a class="el" href="classOgre_1_1HardwareOcclusionQuery.html#d9ae2ba4b9c5f443a8bb423ddeb6121b">Ogre::HardwareOcclusionQuery::mPixelCount</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreHardwareOcclusionQuery_8h-source.html#l00118">118</a> of file <a class="el" href="OgreHardwareOcclusionQuery_8h-source.html">OgreHardwareOcclusionQuery.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="320c1bab88bacc137b8d939a1785da7b"></a><!-- doxytag: member="Ogre::HardwareOcclusionQuery::mIsQueryResultStillOutstanding" ref="320c1bab88bacc137b8d939a1785da7b" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classOgre_1_1HardwareOcclusionQuery.html#320c1bab88bacc137b8d939a1785da7b">Ogre::HardwareOcclusionQuery::mIsQueryResultStillOutstanding</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreHardwareOcclusionQuery_8h-source.html#l00120">120</a> of file <a class="el" href="OgreHardwareOcclusionQuery_8h-source.html">OgreHardwareOcclusionQuery.h</a>.</p>

</div>
</div><p>
<hr>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreHardwareOcclusionQuery_8h-source.html">OgreHardwareOcclusionQuery.h</a></ul>
<hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:49:56 2008
</p>
</body>
</html>
